require 'allow'

class User
  include Allow::Actor
end

class Post
  attr_reader :author
  def initialize(author)
    @author = author
  end
end

class Permissions
  include Allow::Permissions
  def update_post(user, post)
    user == post.author
  end
end

tst "including Allow::Can gets you the :can? method" do
  user = User.new
  assert user.respond_to?(:can?)
end

tst "#can? does what you'd expect" do
  author = User.new
  reader = User.new
  post = Post.new(author)
  Allow.permissions = Permissions.new

  assert_equal true, author.can?(:update_post, post)
  assert_equal false, reader.can?(:update_post, post)

  Allow.reset!
end
