require 'allow'

tst "Allow.ed? delegates to the permissions object :permitted? method" do
  Allow.permissions = Class.new {
    def permitted?(*args) "permitted? called with: #{args}" end
  }.new

  result = Allow.ed?(:actor, :verb, :object)
  assert_equal 'permitted? called with: [:actor, :verb, :object]', result

  Allow.reset!
end

#
# Tests for when Allow.ed? is passed a block:
#

tst "Allow.ed? does NOT execute the block if permitted? => false" do
  Allow.permissions = Class.new {
    def permitted?(*args) false end
  }.new

  Allow.ed?(:actor, :verb, :object) { raise "This shouldn't get reached!!" }

  Allow.reset!
end

tst "Allow.ed? executes the block if permitted? => true" do
  Allow.permissions = Class.new {
    def permitted?(*args) true end
  }.new

  assert_raises RegexpError do
    Allow.ed?(:actor, :verb, :object) { raise RegexpError }
  end

  Allow.reset!
end
