require 'allow'

class Permissions
  include Allow::Permissions
  def answer(s, o) 42 end
  def number(s, o) 42 end
  def string(s, o) 'a string' end
  def nil(s, o) nil end
end

tst "#permitted? defaults to false" do
  permissions = Permissions.new
  permitted = permissions.permitted?(:actor, :verb, :object)
  assert_equal false, permitted
end

tst "#permitted? coerces the result to a boolean" do
  permissions = Permissions.new

  assert_equal true, permissions.permitted?('', :number, '')
  assert_equal true, permissions.permitted?('', :string, '')
  assert_equal false, permissions.permitted?('', :nil, '')
  assert_equal false, permissions.permitted?('', :undefined, '')
end

tst "#permitted? passes the actor and object(s) as args" do
  permissions = Permissions.new

  def permissions.do_something(*args)
    args == [:actor, :object]
  end

  assert permissions.permitted?(:actor, :do_something, :object)
end

tst "#permitted? can pass multiple objects through" do
  permissions = Permissions.new

  def permissions.do_something(*args)
    args == [:actor, :object1, :object2]
  end

  assert permissions.permitted?(:actor, :do_something, :object1, :object2)
end
